--
-- Camera
--
-- Rckfahr-Kamera
--
-- by MMAgrarservice
--
-- edited 18.06.2013 upsidedown: individual inputbinding, bugfix for leaving with activated camera, transformGroup for adding camera on moving implement parts

Camera = {};

function Camera.prerequisitesPresent(specializations)
    return true;
end;

function Camera:load(xmlFile)
	self.CameraPosX = 0.38;
	self.CameraWidth = 0.32;
	self.CameraPosY = 0.74;
	self.CameraHeight = 0.24;
        self.CameraFrame = Utils.getFilename("Huds/Camera.dds", self.baseDirectory);
	self.CameraFrameOverlay = Overlay:new("CameraFrameOverlay", self.CameraFrame, self.CameraPosX, self.CameraPosY, self.CameraWidth, self.CameraHeight);
	self.showCamera = 0;
	
	self.rearCamObject = Utils.indexToObject(self.components, getXMLString(xmlFile,"vehicle.Camera#index"));
end;

function Camera:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Camera:keyEvent(unicode, sym, modifier, isDown)
end;

function Camera:update(dt)
	if self:getIsActiveForInput(true) then
		if InputBinding.hasEvent(InputBinding.Camera) then
			self.showCamera = self.showCamera+1;
			if self.showCamera == 2 then
				self.showCamera = 0;
			end;
		end;
	else
		if self.Camera ~= 0 then
			self.Camera = 0;
			link(self.rootNode, self.Camera);
			node = getRootNode(0);
			setRootNode(node, 1);
			setViewport(1, 0.38, 0.02, 0.32, 0.24);
			setCamera(self.Camera,1);
		end
	end;
end;

	
function Camera:draw()
	if self:getIsActiveForInput(true) then
		g_currentMission:addHelpButtonText(g_i18n:getText("Camera"),  InputBinding.Camera);
		if self.showCamera == 0 then
			self.Camera = 0;
			link(self.rootNode, self.Camera);
			node = getRootNode(0);
			setRootNode(node, 1);
			setViewport(1, 0.38, 0.02, 0.32, 0.24);
			setCamera(self.Camera,1);
		elseif self.showCamera == 1 then
			self.Camera = createCamera("Camera", 90, 0.1, 100);
			link(self.rootNode, self.Camera);
			local xW,yW,zW = getWorldTranslation(self.rearCamObject)			
			local x,y,z = worldToLocal(self.rootNode,xW,yW,zW)
			setTranslation(self.Camera,x,y,z);
			x,y,z = getRotation(self.rearCamObject);
			setRotation(self.Camera,x,y,z);
			node = getRootNode(0);
			setRootNode(node, 1);
			setViewport(1, 0.38, 0.02, 0.32, 0.24);
			setCamera(self.Camera,1);
			self.CameraFrameOverlay:render();
		end;
	end
end;

function Camera:delete()
		self.Camera = 0;
		link(self.rootNode, self.Camera);
		node = getRootNode(0);
		setRootNode(node, 1);
		setViewport(1, 0.38, 0.02, 0.32, 0.24);
		setCamera(self.Camera,1);
end;

-- function Camera:onLeave()
		-- self.Camera = 0;
		-- link(self.rootNode, self.Camera);
		-- node = getRootNode(0);
		-- setRootNode(node, 1);
		-- setViewport(1, 0.38, 0.02, 0.32, 0.24);
		-- setCamera(self.Camera,1);
-- end;